/*...data una rappresentazione di una stanza rettangolare contenente 
 *degli ostacoli (matrice n*m di int, in cui 0 rappresenta uno spazio vuoto, 
 *e 1 rappresenta un ostacolo),  stampa un percorso possibile per raggiungere
 * un angolo della stanza a partire da quello opposto.
*/


public class Esercizio1{

	public static void main(String Args[]){
		
		int[][] stanza=new int[][]{
			{0,1,0,0},
			{0,0,0,0},
			{0,0,1,0},
			{0,1,0,0},
			{0,0,0,0}
		};
				
		cercaPercorso(0,0,stanza);
		
		
	}
	
	static boolean cercaPercorso(int riga,int colonna, int[][] stanza){
		
		System.out.println("visito ("+riga+","+colonna+")");
		
		//se la posizione raggiunta  fuori della stanza restituisce false
		if(riga<0 | riga>=stanza.length)return false;
		if(colonna<0 | colonna>=stanza[0].length)return false;
		
		//se la posizione raggiunta  un ostacolo restituisce false
		if(stanza[riga][colonna]==1)return false;
		
		//se la posizione indicata  gi stata visitata, restituisce false
		if(stanza[riga][colonna]==2)return false;
		
		//se la posizione raggiunta  il goal, stamp il goal e restituisce true
		if((riga==stanza.length-1)&(colonna==stanza[0].length-1)){
			System.out.println("("+riga+","+colonna+")");
			return true;
		}	
				
			
		//data una posizione, attuale 
		//e una matrice contenente tutte le posizioni gi visitate
		//verifica se c' una casa adiacente libera
		
		stanza[riga][colonna]=2;
		
		for(int i=riga-1; i<=riga+1; i++){
			for(int j=colonna-1; j<=colonna+1; j++){
				if(!(j==riga & i==colonna)){
					if(cercaPercorso(i,j,stanza)){
						System.out.println("("+riga+","+colonna+")");
						return true;
					}	
				}	
			}	
		}	
			
		//se non ha trovato alcun percorso possibile, cancella le tracce lasciate e restituisce false
		stanza[riga][colonna]=0;
		return false;
	}	
	
}//end of class 