//Scrivere, compilare ed eseguire un programma Java che... 
//...data una lista di valori interi, costruisce un albero binario 
//di ricerca(4) contenente tali valori.


public class Esercizio14{
		
	public static void main(String[] Args){
	
		int[] listaInteri=new int[]{3,5,8,6,3,2,9,17,25,3,22,24,56,11,34};
		
		
		int[] albero=new int[1];
		albero[0]=3;
		for(int i=1;i<listaInteri.length;i++){
			albero=inserisci(albero,0,listaInteri[i]);
		}
		stampaArray(albero);
	}	
	
	
	
	
	//restituisce un nuovo albero ottenuto inserendo un nodo
	public static int[] inserisci(int[] albbin, int indiceRadice,int valore){
		int[] nuovoAlbero;
		if(albbin[indiceRadice]>valore){
			//se il valore  minore di quello della radice, scendo a sx
			int indiceRadiceFiglioSx=((indiceRadice+1)*2)-1;
			if(indiceRadiceFiglioSx>albbin.length){
				//se il sottoalbero sinistro  fuori range, devo espandere la rappresentazione
				//di un livello			
				nuovoAlbero=new int[(albbin.length*2)+1];
				copiaArray(albbin,nuovoAlbero);
				for(int i=albbin.length;i<nuovoAlbero.length;i++){
					nuovoAlbero[i]=-1;
				}	
				nuovoAlbero[indiceRadiceFiglioSx]=valore;
				return nuovoAlbero;
				
			}
			else{
				if(albbin[indiceRadiceFiglioSx]==-1){	
					//se il sottoalbero sinistro  nel range ma non esiste, posso aggiungerlo senza cambiare le dimensioni
					nuovoAlbero=new int[albbin.length];
					copiaArray(albbin,nuovoAlbero);
					nuovoAlbero[indiceRadiceFiglioSx]=valore;
					return nuovoAlbero;
				}
				else{
					//se il sottoalbero sinistro esiste, inserisco ricorsivamente il nodo
					return inserisci(albbin,indiceRadiceFiglioSx,valore);
				}		
			}
		}
		else{
			//scendo a dx
			//se il valore  minore di quello della radice, scendo a sx
			int indiceRadiceFiglioDx=((indiceRadice+1)*2)+1-1;
			if(indiceRadiceFiglioDx>albbin.length){
				//se il sottoalbero sinistro  fuori range, devo espandere la rappresentazione
				//di un livello			
				nuovoAlbero=new int[(albbin.length*2)+1];
				copiaArray(albbin,nuovoAlbero);
				for(int i=albbin.length;i<nuovoAlbero.length;i++){
					nuovoAlbero[i]=-1;
				}	
				nuovoAlbero[indiceRadiceFiglioDx]=valore;
				return nuovoAlbero;
				
			}
			else{
				if(albbin[indiceRadiceFiglioDx]==-1){	
					//se il sottoalbero sinistro  nel range ma non esiste, posso aggiungerlo senza cambiare le dimensioni
					nuovoAlbero=new int[albbin.length];
					copiaArray(albbin,nuovoAlbero);
					nuovoAlbero[indiceRadiceFiglioDx]=valore;
					return nuovoAlbero;
				}
				else{
					//se il sottoalbero sinistro esiste, inserisco ricorsivamente il nodo
					return inserisci(albbin,indiceRadiceFiglioDx, valore);
				}		
			}
			
		}	
			
	}	
	
	
	//copia il primo nel secondo e azzera
	public static void copiaArray(int[] source,int[] target ){
		for(int i=0;i<source.length;i++){
			target[i]=source[i];
		}	
	}	
	
}