//Scrivere, compilare ed eseguire un programma Java che... 
//...data una lista di valori interi, crea una lista che contiene gli stessi valori, ma senza duplicati.




public class Esercizio2{
		
	public static void main(String[] Args){
	
		int[] listaInteri=new int[]{3,5,8,6,3,2,9,17,25,3,22,24,56,11,34};
		
		int[] listaSenzaDuplicati=eliminaDuplicati(listaInteri);
		
		stampaArray(listaSenzaDuplicati);
		
	}	
	
	public static int[] eliminaDuplicati(int[] lista){
		//se la lista passata  vuota, si restituisce una nuova lista vuota
		if(lista.length==0){
			return new int[0];
		}
		
		//usiamo una lista di appoggio, con numero di elementi pari a quella
		//iniziale, e un intero che punta all'ultimo elemento della lista +1 
		//(cio restituisce la lunghezza della lista temporanea)
		int[] appoggio=new int[lista.length];
		
		//nota: siamo sicuri che la lista abbia almeno un elemento.
		appoggio[0]=lista[0];
		int lunghezzaAppoggio=1;
		
		for(int i=1;i<lista.length;i++){
			boolean giaInserito=false;
			
			//verifico che l'elemento non sia stato gi inserito nella lista di appoggio
			for(int j=0;j<lunghezzaAppoggio;j++){
				if(appoggio[j]==lista[i])
					giaInserito=true;
			}	
			//se non  stato gi inserito, lo inserisco 
			if(!giaInserito){
				appoggio[lunghezzaAppoggio]=lista[i];
				lunghezzaAppoggio++;
			}	
		}	
		
		//creo una lista delle dimensioni corrette 
		//(cio la lunghezza attuale di lunghezzaAppoggio), 
		//e la riempio
		int[] risultato=new int[lunghezzaAppoggio];
		for(int i=0;i<lunghezzaAppoggio;i++){
			risultato[i]=appoggio[i];
		}
		
		return risultato;
	}	
	
	
	//metodo utilit, stampa un array lineare
	public static void stampaArray(int[] array){
		if(array.length==0){
			System.out.println("L'array ha lunghezza nulla");
			return;
		}	
		System.out.print("[");
		for(int i=0;i<array.length;i++){
			System.out.print(array[i]);
			if(i<array.length-1)
				System.out.print(",");
		}	
		System.out.println("]");
	}	
	
}	