//Scrivere, compilare ed eseguire un programma Java che... 
//...data una matrice di interi, verifica se  un quadrato magico, ovvero se
//la somma dei valori su ciascuna riga e colonna  lo stesso.



public class Esercizio7{
		
	public static void main(String[] Args){
	
		int[][] matrice1=new int[][]{
		{3,5,8},
		{6,3,2},
		{9,17,25}
		};
		
		int[][] matrice2=new int[][]{
		{8,1,6},
		{3,5,7},
		{4,9,2}
		};
		
		System.out.println(isMagic(matrice1));
		System.out.println(isMagic(matrice2));
				
	}	
	
	public static boolean isMagic(int[][]m){
		
		if(m.length!=m[0].length){
			System.out.println("la matrice non  un quadrato!");
			return false;
		}	
		
		boolean magic=true;
		int dim=m.length;
		int sum=-1;
		int partialSum;
		
		//somma per righe
		for(int i=0;i<dim;i++){
			partialSum=0;
			for(int j=0;j<dim;j++){
				partialSum=partialSum+m[i][j];
			}	
			if(sum==-1){
				sum=partialSum;
			}	
			else{
				if(sum!=partialSum)magic=false;
			}	
		}	
		
		//somma per colonne
		for(int i=0;i<dim;i++){
			partialSum=0;
			for(int j=0;j<dim;j++){
				partialSum=partialSum+m[j][i];
			}	
			if(sum!=partialSum)magic=false;	
		}
		
		
		//somma sulle diagonali
		partialSum=0;
		for(int i=0;i<dim;i++){
			partialSum=partialSum+m[i][i];
		}	
		if(sum!=partialSum)magic=false;
		
		//somma sulle diagonali
		partialSum=0;
		for(int i=0;i<dim;i++){
			partialSum=partialSum+m[i][dim-i-1];
		}	
		if(sum!=partialSum)magic=false;
		
		return magic;
	}	
	
}	