//Scrivere, compilare ed eseguire un programma Java che... 
//...data una rappresentazione di una scacchiera (8x8) tramite una matrice di char,
//in cui '-' indica una casa vuota e 'Q' una regina, determina se  una soluzione per
//il problema delle 8 regine. Si ricorda che il problema consiste nel collocare sulla 
//scacchiera 8 regine in modo che nessuna sia minacciata da un'altra,
//ovvero che nessuna si trovi sulla stessa riga, colonna o diagonale di un'altra. 



public class Esercizio8{
		
	public static void main(String[] Args){
	
		char[][] scacchiera=new char[][]{
		{'-','-','-','q','-','-','-','-'},
		
		{'-','-','-','-','-','-','q','-'},
		
		{'-','-','q','-','-','-','-','-'},
		
		{'-','-','-','-','-','-','-','q'},
		
		{'-','q','-','-','-','-','-','-'},
		
		{'-','-','-','-','q','-','-','-'},
		
		{'q','-','-','-','-','-','-','-'},
		
		{'-','-','-','-','-','q','-','-'}
		};
		
		
		
		System.out.println(soluzione(scacchiera));
		
						
	}	
	
	
	public static boolean soluzione(char[][] scacchiera){
		for(int i=0;i<scacchiera.length;i++){
			for(int j=0;j<scacchiera.length;j++){
				if(scacchiera[i][j]=='q')
				  if(minacciata(i,j,scacchiera))
				  	return false;
			}
		}
		return true;
	}	
	
	
	
	public static boolean minacciata(int riga,int colonna, char[][]scacchiera){
		
		int dim=scacchiera.length;
		int numRegine=0;
		
		//minaccia sulla riga
		for(int i=0;i<dim;i++){
			if(scacchiera[riga][i]=='q')numRegine++;
		}	
		if(numRegine>1)return true;
		
		
		//minaccia sulla colonna
		numRegine=0;
		for(int i=0;i<dim;i++){
			if(scacchiera[i][colonna]=='q')numRegine++;
		}	
		if(numRegine>1)return true;
		
		
		numRegine=0;
		for(int i=0;(riga+i)<dim&(colonna+i)<dim;i++)
			if(scacchiera[riga+i][colonna+i]=='q')numRegine++;
		if(numRegine>1)return true;
		
		
		numRegine=0;
		for(int i=0;(riga+i)<dim&(colonna-i)>=0;i++)
			if(scacchiera[riga+i][colonna-i]=='q')numRegine++;
		if(numRegine>1)return true;
			
			
		numRegine=0;	
		for(int i=0;(riga-i)>=0&(colonna+i)<dim;i++)
			if(scacchiera[riga-i][colonna+i]=='q')numRegine++;
		if(numRegine>1)return true;
			
		numRegine=0;	
		for(int i=0;(riga-i)>=0&(colonna-i)>=0;i++)
			if(scacchiera[riga-i][colonna-i]=='q')numRegine++;
		if(numRegine>1)return true;	
		
		return false;
	
	}	

}