//Scrivere, compilare ed eseguire un programma Java che... 
//...data una lista di valori interi, la ordina in senso decrescente.



//Nota:
//Ho implementato l'algoritmo ricorsivo mergesort
//Quest'implementazione non  ottimale, crea molta memoria dinamica non necessaria (array per contenere i risultati intermedi)
//ma spero che sia pi chiara da interpretare della versione ottimale.



public class Esercizio5{
		
	public static void main(String[] Args){
	
		int[] listaInteri=new int[]{3,5,8,6,3,2,9,17,25,3,22,24,56,11,34};
		
		stampaArray(sort(listaInteri));
				
	}	
	
	public static int[] sort(int[] lista){
		
		if(lista.length==1){
			int[] risultato=new int[1];
			risultato[0]=lista[0];
			return risultato;
		}	
		
		if(lista.length==2){
			int[] risultato=new int[2];
			if(lista[0]>=lista[1]){
				risultato[0]=lista[0];
				risultato[1]=lista[1];
			}	
			else{
				risultato[0]=lista[1];
				risultato[1]=lista[0];
			}	
			return risultato;
		}
		
		if(lista.length>2){
			int lunghezza1=lista.length/2;
			int lunghezza2=lista.length-lunghezza1;
			
			int[] segmento1=new int[lunghezza1];
			for(int i=0;i<lunghezza1;i++){
				segmento1[i]=lista[i];
			}	
			
			int[] segmento2=new int[lunghezza2];
			for(int i=0;i<lunghezza2;i++){
				segmento2[i]=lista[i+lunghezza1];
			}
			
			return merge(sort(segmento1),sort(segmento2));
		}	
		
		
		//return finale, si applica se la lista passata ha lunghezza zero
		return new int[0];
		
	}	


	public static int[] merge(int[] segmento1, int[] segmento2){
		int[] risultato=new int[segmento1.length+segmento2.length];
		int currpos1=0;
		int currpos2=0;
		int posRisultato;
		for(posRisultato=0;posRisultato<risultato.length & currpos1<segmento1.length & currpos2<segmento2.length;posRisultato++){
			if(segmento1[currpos1]>=segmento2[currpos2]){
				risultato[posRisultato]=segmento1[currpos1];
				currpos1++;
			}
			else{
				risultato[posRisultato]=segmento2[currpos2];
				currpos2++;
			}		
		}	
		if(currpos1<segmento1.length){
			for(int i=0;(i+posRisultato)<risultato.length;i++){
				risultato[i+posRisultato]=segmento1[currpos1+i];
			}	
		}	
		if(currpos2<segmento2.length){
			for(int i=0;(i+posRisultato)<risultato.length;i++){
				risultato[i+posRisultato]=segmento2[currpos2+i];
			}	
		}
		return risultato;
	}	
	
	
	//metodo utilit, stampa un array lineare
	public static void stampaArray(int[] array){
		if(array.length==0){
			System.out.println("L'array ha lunghezza nulla");
			return;
		}
		System.out.print("[");
		for(int i=0;i<array.length;i++){
			System.out.print(array[i]);
			if(i<array.length-1)
				System.out.print(",");
		}	
		System.out.println("]");
	}
	
}	